package cofh.thermal.expansion;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.config.IBaseConfig;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.expansion.config.ThermalDynamoConfig;
import cofh.thermal.expansion.config.ThermalMachineConfig;
import cofh.thermal.expansion.init.TExpBlocks;
import cofh.thermal.expansion.init.TExpContainers;
import cofh.thermal.expansion.init.TExpItems;
import cofh.thermal.expansion.init.TExpSounds;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.lib.common.ThermalFlags;
import net.minecraft.client.gui.screens.MenuScreens;
import net.minecraft.client.renderer.ItemBlockRenderTypes;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.level.block.Block;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;

@Mod("thermal_expansion")
public class ThermalExpansion {
  public ThermalExpansion() {
    setFeatureFlags();
    IEventBus modEventBus = FMLJavaModLoadingContext.get().getModEventBus();
    ThermalCore.CONFIG_MANAGER.register(modEventBus)
      .addServerConfig((IBaseConfig)new ThermalDynamoConfig())
      .addServerConfig((IBaseConfig)new ThermalMachineConfig());
    modEventBus.addListener(this::commonSetup);
    modEventBus.addListener(this::clientSetup);
    TExpBlocks.register();
    TExpItems.register();
    TExpContainers.register();
    TExpSounds.register();
    TExpTileEntities.register();
  }
  
  private void setFeatureFlags() {
    ThermalFlags.setFlag(ThermalFlags.FLAG_RESOURCE_CINNABAR, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_RESOURCE_OIL, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_DYNAMO_AUGMENTS, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_MACHINE_AUGMENTS, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_TOOL_COMPONENTS, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_COINS, true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_PLATES, true);
    ThermalFlags.setFlag("machine_frame", true);
    ThermalFlags.setFlag("device_tree_extractor", true);
    ThermalFlags.setFlag("device_fisher", true);
    ThermalFlags.setFlag("device_composter", true);
    ThermalFlags.setFlag("device_water_gen", true);
    ThermalFlags.setFlag("device_rock_gen", true);
    ThermalFlags.setFlag("device_collector", true);
    ThermalFlags.setFlag("device_nullifier", true);
    ThermalFlags.setFlag("device_potion_diffuser", true);
    ThermalFlags.setFlag("dynamo_stirling", true);
    ThermalFlags.setFlag("dynamo_compression", true);
    ThermalFlags.setFlag("dynamo_magmatic", true);
    ThermalFlags.setFlag("dynamo_numismatic", true);
    ThermalFlags.setFlag("dynamo_lapidary", true);
    ThermalFlags.setFlag("dynamo_disenchantment", true);
    ThermalFlags.setFlag("dynamo_gourmand", true);
    ThermalFlags.setFlag("machine_furnace", true);
    ThermalFlags.setFlag("machine_sawmill", true);
    ThermalFlags.setFlag("machine_pulverizer", true);
    ThermalFlags.setFlag("machine_smelter", true);
    ThermalFlags.setFlag("machine_insolator", true);
    ThermalFlags.setFlag("machine_centrifuge", true);
    ThermalFlags.setFlag("machine_press", true);
    ThermalFlags.setFlag("machine_crucible", true);
    ThermalFlags.setFlag("machine_chiller", true);
    ThermalFlags.setFlag("machine_refinery", true);
    ThermalFlags.setFlag("machine_pyrolyzer", true);
    ThermalFlags.setFlag("machine_bottler", true);
    ThermalFlags.setFlag("machine_brewer", true);
    ThermalFlags.setFlag("machine_crystallizer", true);
    ThermalFlags.setFlag("machine_crafter", true);
    ThermalFlags.setFlag("energy_cell_frame", true);
    ThermalFlags.setFlag("energy_cell", true);
    ThermalFlags.setFlag("fluid_cell_frame", true);
    ThermalFlags.setFlag("fluid_cell", true);
    ThermalFlags.setFlag(ThermalFlags.FLAG_XP_STORAGE_AUGMENT, true);
  }
  
  private void commonSetup(FMLCommonSetupEvent event) {}
  
  private void clientSetup(FMLClientSetupEvent event) {
    event.enqueueWork(this::registerGuiFactories);
    event.enqueueWork(this::registerRenderLayers);
  }
  
  private void registerGuiFactories() {
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_FURNACE_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineFurnaceScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_SAWMILL_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineSawmillScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_PULVERIZER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachinePulverizerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_SMELTER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineSmelterScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_INSOLATOR_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineInsolatorScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_CENTRIFUGE_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineCentrifugeScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_PRESS_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachinePressScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_CRUCIBLE_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineCrucibleScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_CHILLER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineChillerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_REFINERY_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineRefineryScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_PYROLYZER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachinePyrolyzerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_BREWER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineBrewerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_BOTTLER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineBottlerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_CRYSTALLIZER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineCrystallizerScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.MACHINE_CRAFTER_CONTAINER.get(), cofh.thermal.expansion.client.gui.machine.MachineCrafterScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_STIRLING_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoStirlingScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_COMPRESSION_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoCompressionScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_MAGMATIC_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoMagmaticScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_NUMISMATIC_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoNumismaticScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_LAPIDARY_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoLapidaryScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_DISENCHANTMENT_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoDisenchantmentScreen::new);
    MenuScreens.m_96206_((MenuType)TExpContainers.DYNAMO_GOURMAND_CONTAINER.get(), cofh.thermal.expansion.client.gui.dynamo.DynamoGourmandScreen::new);
  }
  
  private void registerRenderLayers() {
    RenderType cutout = RenderType.m_110463_();
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_furnace"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_sawmill"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_pulverizer"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_smelter"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_insolator"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_centrifuge"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_press"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_crucible"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_chiller"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_refinery"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_pyrolyzer"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_bottler"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_brewer"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_crystallizer"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("machine_crafter"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_stirling"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_compression"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_magmatic"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_numismatic"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_lapidary"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_disenchantment"), cutout);
    ItemBlockRenderTypes.setRenderLayer((Block)ThermalCore.BLOCKS.get("dynamo_gourmand"), cutout);
  }
}
